/****************************************
 * Reception et affichage des donnees de capteurs
 * Module 1 entree analogique vers Midi
 * Interface-Z
 * Sensors data reception and display from
 * 1 analogical way
 *****************************************/

// Importer la library the Midibus
// http://smallbutdigital.com/themidibus.php
import themidibus.*; 
MidiBus myBus; 

PFont policeperso;

void setup() {
  size(400, 200);
  smooth();
  noStroke();
  background(0);

  // Liste des peripheriques Midi disponibles sur l'ordinateur
  // Displaying Midi devices existing on the computer  
  MidiBus.list(); 

  // Ouverture de port (this, In, Out)
  // Choisir le numero du peripherique dans la liste
  // In et Out etant les numeros des peripheriques entrant et sortant
  // Open Midi port (this, In, Out)
  // Choose the appropriate Midi device from the list
  // In and Out being the corresponding In and Out devices
  myBus = new MidiBus(this, 0, -1);
  // -1 pour ne pas ouvrir ce port
  // -1 in order not to open this port
  
  policeperso = loadFont("AonCariCeltic-32.vlw");
  textFont(policeperso, 32);
}

// Reception des capteurs analogiques
// Receiving analogical sensors
int capteur;
int[] registre = new int[24];

void controllerChange(int channel, int number, int value) {
  // Recoit les messages Midi de type Control Change
  // Receive Control Change messages
  if (number == 0) {
    capteur = value;
    // registre a decalage
    for (int i =23; i>0; i = i-1) {
      registre[i] = registre[i-1];
    }
    // une fois la case 0 recopiee sur la case 1,
    // transferer la valeur nouvelle du capteur dans la case 0 du registre  
    registre[0] = capteur;
  }
  println("Control Change : Canal "+channel+" Numero "+number+" Valeur "+capteur);
}

void draw() {
  background(0);
  fill(255);
  text("1 Analogique Midi", 30, 30);
  text(capteur, 30, 100);
  // Affichage de 24 Blocs bleus
  for (int i =0; i<=23; i = i+1 ) {
    fill(20, 100, 100);
    rect(90 + (i*12), 40, 10, 128);
  }

  // Affichage d'un bloc clair dont la hauteur
  // depend de la valeur du capteur
  for (int j = 0; j<=23; j = j+1) {
    fill(j, 255, 255);
    rect(90 + (j*12), 40 + 127 - registre[j], 10, registre[j]);
  }
}

